<html>
<head>
<title>OgreInstancedEntity.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreInstancedEntity.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreInstancedEntity_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __InstancedEntity_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __InstancedEntity_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreNode_8h.html">OgreNode.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre
<a name="l00035"></a>00035 {
<a name="l00076"></a><a class="code" href="classOgre_1_1InstancedEntity.html">00076</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a> : <span class="keyword">public</span> Ogre::<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>
<a name="l00077"></a>00077     {
<a name="l00078"></a><a class="code" href="group__Scene.html#gab0ddd6acb1bcb90f4ac672b7ba7569b0">00078</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a>;
<a name="l00079"></a><a class="code" href="group__Scene.html#gaf05a8273f12bc11f025607a06b3b3e2a">00079</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1InstanceBatchShader.html" title="This is the same technique the old &quot;InstancedGeometry&quot; implementation used (with improvements).">InstanceBatchShader</a>;
<a name="l00080"></a><a class="code" href="group__Scene.html#ga204d0aed3320790edf10711c32f3db73">00080</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1InstanceBatchHW.html" title="This is technique requires true instancing hardware support.">InstanceBatchHW</a>;
<a name="l00081"></a><a class="code" href="group__Scene.html#ga9534bbd3a2646322b2767289cb9c972c">00081</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1InstanceBatchHW__VTF.html" title="Instancing implementation using vertex texture through Vertex Texture Fetch (VTF) and hardware instan...">InstanceBatchHW_VTF</a>;
<a name="l00082"></a><a class="code" href="group__Scene.html#ga41ffb53da525c94819e85211fc48449c">00082</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1BaseInstanceBatchVTF.html" title="Instancing implementation using vertex texture through Vertex Texture Fetch (VTF) This implementation...">BaseInstanceBatchVTF</a>;
<a name="l00083"></a>00083     <span class="keyword">protected</span>:
<a name="l00084"></a><a class="code" href="group__Scene.html#gabcc6bec0970aa779efd6715890b5f00a">00084</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="group__Scene.html#gabcc6bec0970aa779efd6715890b5f00a">mInstanceId</a>; <span class="comment">//Note it may change after defragmenting!</span>
<a name="l00085"></a><a class="code" href="group__Scene.html#ga55a3fe20143481524c0c5bf751d8d365">00085</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga55a3fe20143481524c0c5bf751d8d365">mInUse</a>;
<a name="l00086"></a><a class="code" href="group__Scene.html#ga0b87d95bd492a7e115e8d8306adb533e">00086</a>         <a class="code" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a> *<a class="code" href="group__Scene.html#ga0b87d95bd492a7e115e8d8306adb533e">mBatchOwner</a>;
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="group__Scene.html#gaac98ad4a328eb3822c5e32ee13fae177">00088</a>         <a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a> *<a class="code" href="group__Scene.html#gaac98ad4a328eb3822c5e32ee13fae177">mAnimationState</a>;
<a name="l00089"></a><a class="code" href="group__Scene.html#gab7d408b6c09d48f7978574d6a5f27081">00089</a>         <a class="code" href="classOgre_1_1SkeletonInstance.html" title="A SkeletonInstance is a single instance of a Skeleton used by a world object.">SkeletonInstance</a> *<a class="code" href="group__Scene.html#gab7d408b6c09d48f7978574d6a5f27081">mSkeletonInstance</a>;
<a name="l00090"></a><a class="code" href="group__Scene.html#ga8ba4f6cf7c88597ffc6fea3da64d3454">00090</a>         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> *<a class="code" href="group__Scene.html#ga8ba4f6cf7c88597ffc6fea3da64d3454">mBoneMatrices</a>;  <span class="comment">//Local space</span>
<a name="l00091"></a><a class="code" href="group__Scene.html#ga9284c3e1a0d1731f1a1dc3aa47605b00">00091</a>         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> *<a class="code" href="group__Scene.html#ga9284c3e1a0d1731f1a1dc3aa47605b00">mBoneWorldMatrices</a>; <span class="comment">//World space</span>
<a name="l00092"></a><a class="code" href="group__Scene.html#gad0e2494c8a83a24ef1e5ec060845ae6b">00092</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="group__Scene.html#gad0e2494c8a83a24ef1e5ec060845ae6b">mFrameAnimationLastUpdated</a>;
<a name="l00093"></a>00093 
<a name="l00094"></a><a class="code" href="group__Scene.html#ga6cf7f799d30adffc36f9aef190c6f0d4">00094</a>         <a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a>* <a class="code" href="group__Scene.html#ga6cf7f799d30adffc36f9aef190c6f0d4">mSharedTransformEntity</a>;    <span class="comment">//When not null, another InstancedEntity controls the skeleton</span>
<a name="l00095"></a>00095                                                 
<a name="l00098"></a><a class="code" href="group__Scene.html#ga8523dc34690677725c0538f042052a45">00098</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="group__Scene.html#ga8523dc34690677725c0538f042052a45" title="Used in conjunction with bone matrix lookup.">mTransformLookupNumber</a>;
<a name="l00099"></a>00099 
<a name="l00101"></a><a class="code" href="group__Scene.html#gaafff23952db909d80163ae29411d4710">00101</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;InstancedEntity*&gt;::type</a> <a class="code" href="group__Scene.html#gaafff23952db909d80163ae29411d4710" title="Stores the master when we&#39;re the slave, store our slaves when we&#39;re the master.">InstancedEntityVec</a>;
<a name="l00102"></a><a class="code" href="group__Scene.html#ga0fc7d99eecd4724c321671fc0e22f0a9">00102</a>         <a class="code" href="group__Scene.html#gaafff23952db909d80163ae29411d4710" title="Stores the master when we&#39;re the slave, store our slaves when we&#39;re the master.">InstancedEntityVec</a> <a class="code" href="group__Scene.html#ga0fc7d99eecd4724c321671fc0e22f0a9">mSharingPartners</a>;
<a name="l00103"></a>00103 
<a name="l00105"></a>00105         <span class="comment">// Parameters used for local transformation offset information</span>
<a name="l00106"></a>00106         <span class="comment">// The </span>
<a name="l00108"></a>00108 <span class="comment"></span>
<a name="l00110"></a><a class="code" href="group__Scene.html#gaa1ec7b40dde67eea8b3b96783bd72944">00110</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="group__Scene.html#gaa1ec7b40dde67eea8b3b96783bd72944" title="Object position.">mPosition</a>;
<a name="l00111"></a><a class="code" href="group__Scene.html#gadd52bbb1039087eaccc90bae9cb9d499">00111</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="group__Scene.html#gadd52bbb1039087eaccc90bae9cb9d499">mDerivedLocalPosition</a>;
<a name="l00113"></a><a class="code" href="group__Scene.html#gaa9fb09138d9b6bc5c5a18823456208ed">00113</a>         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="group__Scene.html#gaa9fb09138d9b6bc5c5a18823456208ed" title="Object orientation.">mOrientation</a>;
<a name="l00115"></a><a class="code" href="group__Scene.html#gab7aa07159e942edda90e72d59f8ef141">00115</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="group__Scene.html#gab7aa07159e942edda90e72d59f8ef141" title="Object scale.">mScale</a>;
<a name="l00117"></a><a class="code" href="group__Scene.html#ga37742aee6cbcfd03cc436a6488010b7d">00117</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="group__Scene.html#ga37742aee6cbcfd03cc436a6488010b7d" title="The maximum absolute scale for all dimension.">mMaxScaleLocal</a>;
<a name="l00119"></a><a class="code" href="group__Scene.html#ga0b0834ba89b7f29cd716b6a276f3af39">00119</a>         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="group__Scene.html#ga0b0834ba89b7f29cd716b6a276f3af39" title="Full world transform.">mFullLocalTransform</a>;
<a name="l00121"></a><a class="code" href="group__Scene.html#ga349119edf5a0fc5e411711dba2a057ab">00121</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga349119edf5a0fc5e411711dba2a057ab" title="Tells if mFullTransform needs an updated.">mNeedTransformUpdate</a>;
<a name="l00123"></a><a class="code" href="group__Scene.html#ga94a2fc186ce414f29e3048c9021d27a1">00123</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga94a2fc186ce414f29e3048c9021d27a1" title="Tells if the animation world transform needs an update.">mNeedAnimTransformUpdate</a>;
<a name="l00125"></a><a class="code" href="group__Scene.html#ga891d8f01d57b9643c9f1ade6f2d68674">00125</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga891d8f01d57b9643c9f1ade6f2d68674" title="Tells whether to use the local transform parameters.">mUseLocalTransform</a>;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00129"></a>00129         <span class="keywordtype">size_t</span> getTransforms( <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> *xform ) <span class="keyword">const</span>;
<a name="l00131"></a>00131         <span class="keywordtype">size_t</span> getTransforms3x4( <span class="keywordtype">float</span> *xform ) <span class="keyword">const</span>;
<a name="l00132"></a>00132 
<a name="l00134"></a>00134         <span class="keywordtype">bool</span> findVisible( <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *camera ) <span class="keyword">const</span>;
<a name="l00135"></a>00135 
<a name="l00137"></a>00137         <span class="keywordtype">void</span> createSkeletonInstance();
<a name="l00138"></a>00138         <span class="keywordtype">void</span> destroySkeletonInstance();
<a name="l00139"></a>00139 
<a name="l00141"></a>00141         <span class="keywordtype">void</span> unlinkTransform();
<a name="l00142"></a>00142 
<a name="l00144"></a>00144         <span class="keywordtype">void</span> notifyUnlink( <span class="keyword">const</span> <a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a> *slave );
<a name="l00145"></a>00145 
<a name="l00147"></a>00147         <span class="keyword">inline</span> <span class="keywordtype">void</span> markTransformDirty();
<a name="l00148"></a>00148 
<a name="l00150"></a><a class="code" href="group__Scene.html#ga9b933773e03cb2a861129c9d265b3e76">00150</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1NameGenerator.html" title="Utility class to generate a sequentially numbered series of names.">NameGenerator</a> <a class="code" href="group__Scene.html#ga9b933773e03cb2a861129c9d265b3e76" title="Incremented count for next name extension.">msNameGenerator</a>;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152     <span class="keyword">public</span>:
<a name="l00153"></a>00153         <a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a>( <a class="code" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a> *batchOwner, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> instanceID, <a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a>* sharedTransformEntity = NULL);
<a name="l00154"></a>00154         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a>();
<a name="l00155"></a>00155 
<a name="l00174"></a>00174         <span class="keywordtype">bool</span> shareTransformWith( <a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a> *slave );
<a name="l00175"></a>00175 
<a name="l00183"></a>00183         <span class="keywordtype">void</span> stopSharingTransform();
<a name="l00184"></a>00184 
<a name="l00185"></a><a class="code" href="group__Scene.html#ga1d072afe938f349921ae81cd06e09368">00185</a>         <a class="code" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a>* <a class="code" href="group__Scene.html#ga1d072afe938f349921ae81cd06e09368">_getOwner</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mBatchOwner; }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00188"></a>00188 
<a name="l00189"></a>00189         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBoundingBox(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00190"></a>00190         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00191"></a>00191 
<a name="l00194"></a>00194         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam ) <span class="keyword">const</span>;
<a name="l00195"></a>00195 
<a name="l00197"></a>00197         <span class="keywordtype">void</span> _notifyMoved(<span class="keywordtype">void</span>);
<a name="l00198"></a>00198         <span class="keywordtype">void</span> _notifyAttached( <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* parent, <span class="keywordtype">bool</span> isTagPoint = <span class="keyword">false</span> );
<a name="l00199"></a>00199 
<a name="l00201"></a><a class="code" href="group__Scene.html#ga0a0d1a414ff9876e426aad8421b4baba">00201</a>         <span class="keywordtype">void</span> <a class="code" href="group__Scene.html#ga0a0d1a414ff9876e426aad8421b4baba" title="Do nothing, InstanceBatch takes care of this.">_updateRenderQueue</a>( <a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue )   {}
<a name="l00202"></a><a class="code" href="group__Scene.html#gab912c25160b445527baf448d3259f8c6">00202</a>         <span class="keywordtype">void</span> <a class="code" href="group__Scene.html#gab912c25160b445527baf448d3259f8c6" title="Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject ...">visitRenderables</a>( <a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor, <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span> ) {}
<a name="l00203"></a>00203 
<a name="l00205"></a><a class="code" href="group__Scene.html#gafc537fce160cf7699c49d4df3f3ffdfb">00205</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#gafc537fce160cf7699c49d4df3f3ffdfb">hasSkeleton</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSkeletonInstance != 0; }
<a name="l00207"></a><a class="code" href="group__Scene.html#gaa757e92d43b49a781dea9936c3601613">00207</a>         <a class="code" href="classOgre_1_1SkeletonInstance.html" title="A SkeletonInstance is a single instance of a Skeleton used by a world object.">SkeletonInstance</a>* <a class="code" href="group__Scene.html#gaa757e92d43b49a781dea9936c3601613">getSkeleton</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSkeletonInstance; }
<a name="l00208"></a>00208 
<a name="l00210"></a>00210         <a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>* getAnimationState(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00212"></a>00212         <a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* getAllAnimationStates(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00213"></a>00213 
<a name="l00219"></a>00219         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> _updateAnimation(<span class="keywordtype">void</span>);
<a name="l00220"></a>00220 
<a name="l00222"></a><a class="code" href="group__Scene.html#gae89c0833c0c9d0c22c8baea6237c8ef5">00222</a>         <span class="keywordtype">void</span> <a class="code" href="group__Scene.html#gae89c0833c0c9d0c22c8baea6237c8ef5" title="Sets the transformation look up number.">setTransformLookupNumber</a>(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> num) { mTransformLookupNumber = num;}
<a name="l00223"></a>00223 
<a name="l00225"></a><a class="code" href="group__Scene.html#ga81b1d5ae36281443d804f08f45204bd5">00225</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="group__Scene.html#ga81b1d5ae36281443d804f08f45204bd5" title="Retrieve the position.">getPosition</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPosition; }
<a name="l00227"></a>00227         <span class="keywordtype">void</span> setPosition(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; position, <span class="keywordtype">bool</span> doUpdate = <span class="keyword">true</span>);
<a name="l00228"></a>00228 
<a name="l00230"></a><a class="code" href="group__Scene.html#ga8669b46de628fc80bcd9c5869edb1ac1">00230</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; <a class="code" href="group__Scene.html#ga8669b46de628fc80bcd9c5869edb1ac1" title="Retrieve the orientation.">getOrientation</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOrientation; }
<a name="l00232"></a>00232         <span class="keywordtype">void</span> setOrientation(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; orientation, <span class="keywordtype">bool</span> doUpdate = <span class="keyword">true</span>);
<a name="l00233"></a>00233 
<a name="l00235"></a><a class="code" href="group__Scene.html#gabc1d8c4eb26eb46605b82f960cb05254">00235</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="group__Scene.html#gabc1d8c4eb26eb46605b82f960cb05254" title="Retrieve the local scale.">getScale</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mScale; }
<a name="l00237"></a>00237         <span class="keywordtype">void</span> setScale(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; scale, <span class="keywordtype">bool</span> doUpdate = <span class="keyword">true</span>);
<a name="l00238"></a>00238 
<a name="l00240"></a>00240         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getMaxScaleCoef() <span class="keyword">const</span>;
<a name="l00241"></a>00241 
<a name="l00243"></a>00243         <span class="keywordtype">void</span> updateTransforms();
<a name="l00244"></a>00244 
<a name="l00246"></a><a class="code" href="group__Scene.html#gac6d67e5072170f924f878f730f6e8548">00246</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#gac6d67e5072170f924f878f730f6e8548" title="Tells if the entity is in use.">isInUse</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mInUse; }
<a name="l00248"></a>00248         <span class="keywordtype">void</span> setInUse(<span class="keywordtype">bool</span> used);
<a name="l00249"></a>00249 
<a name="l00251"></a><a class="code" href="group__Scene.html#gaaa3bfaf1f283e98391ac1b55fb2bd9b6">00251</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; <a class="code" href="group__Scene.html#gaaa3bfaf1f283e98391ac1b55fb2bd9b6" title="Returns the world transform of the instanced entity including local transform.">_getParentNodeFullTransform</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ 
<a name="l00252"></a>00252             assert((!mNeedTransformUpdate || !mUseLocalTransform) &amp;&amp; <span class="stringliteral">&quot;Transform data should be updated at this point&quot;</span>);
<a name="l00253"></a>00253             <span class="keywordflow">return</span> mUseLocalTransform ? mFullLocalTransform :
<a name="l00254"></a>00254                 mParentNode ? mParentNode-&gt;_getFullTransform() : <a class="code" href="classOgre_1_1Matrix4.html#af2f61127dd1911c9ac2b4cbc0b4f3668">Matrix4::IDENTITY</a>;
<a name="l00255"></a>00255         }
<a name="l00256"></a>00256 
<a name="l00258"></a><a class="code" href="group__Scene.html#ga299a18557a9ad2ee7a806d9a61fe9873">00258</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="group__Scene.html#ga299a18557a9ad2ee7a806d9a61fe9873" title="Returns the derived position of the instanced entity including local transform.">_getDerivedPosition</a>()<span class="keyword"> const </span>{
<a name="l00259"></a>00259             assert((!mNeedTransformUpdate || !mUseLocalTransform) &amp;&amp; <span class="stringliteral">&quot;Transform data should be updated at this point&quot;</span>);
<a name="l00260"></a>00260             <span class="keywordflow">return</span> mUseLocalTransform ? mDerivedLocalPosition :
<a name="l00261"></a>00261                 mParentNode ? mParentNode-&gt;_getDerivedPosition() : <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>;
<a name="l00262"></a>00262         }
<a name="l00263"></a>00263 
<a name="l00265"></a><a class="code" href="group__Scene.html#ga68d632a2efac0e4ab0567cee3852871a">00265</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isInScene(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00266"></a>00266 <span class="keyword">        </span>{
<a name="l00267"></a>00267             <span class="comment">//We assume that the instanced entity is in the scene if it is in use</span>
<a name="l00268"></a>00268             <span class="comment">//It is in the scene whether it has a parent node or not</span>
<a name="l00269"></a>00269             <span class="keywordflow">return</span> mInUse;
<a name="l00270"></a>00270         }
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00274"></a>00274     };
<a name="l00275"></a>00275 }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
